{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "1ba77302-6bb4-4c0f-9a2f-9d8c4be83ca3",
   "metadata": {},
   "source": [
    "# Visualizing Data in Kotlin"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "10c6cf3a-ed01-4214-9f84-805d164bfc52",
   "metadata": {},
   "source": [
    "As DataFrame and Multik, **Lets-Plot** library can be imported with the magic command:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "id": "4e155f85-c9a1-40b8-a27a-3bf987144601",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "            <div id=\"kotlin_out_0\"/>\n",
       "            <script type=\"text/javascript\">\n",
       "                            if(!window.kotlinQueues) {\n",
       "                window.kotlinQueues = {};\n",
       "            }\n",
       "            if(!window.kotlinQueues[\"DataFrame\"]) {\n",
       "                var resQueue = [];\n",
       "                window.kotlinQueues[\"DataFrame\"] = resQueue;\n",
       "                window[\"call_DataFrame\"] = function(f) {\n",
       "                    resQueue.push(f);\n",
       "                }\n",
       "            }\n",
       "            (function (){\n",
       "                var modifiers = [(function(script) {\n",
       "    script.src = \"https://cdn.jsdelivr.net/gh/Kotlin/dataframe@3db46ccccaa1291c0627307d64133317f545e6ae/core/src/main/resources/init.js\"\n",
       "    script.type = \"text/javascript\";\n",
       "})];\n",
       "                var e = document.getElementById(\"kotlin_out_0\");\n",
       "                modifiers.forEach(function (gen) {\n",
       "                    var script = document.createElement(\"script\");\n",
       "                    gen(script)\n",
       "                    script.addEventListener(\"load\", function() {\n",
       "                        window[\"call_DataFrame\"] = function(f) {f();};\n",
       "                        window.kotlinQueues[\"DataFrame\"].forEach(function(f) {f();});\n",
       "                        window.kotlinQueues[\"DataFrame\"] = [];\n",
       "                    }, false);\n",
       "                    script.addEventListener(\"error\", function() {\n",
       "                        window[\"call_DataFrame\"] = function(f) {};\n",
       "                        window.kotlinQueues[\"DataFrame\"] = [];\n",
       "                        var div = document.createElement(\"div\");\n",
       "                        div.style.color = 'darkred';\n",
       "                        div.textContent = 'Error loading resource DataFrame';\n",
       "                        document.getElementById(\"kotlin_out_0\").appendChild(div);\n",
       "                    }, false);\n",
       "                    \n",
       "                    e.appendChild(script);\n",
       "                });\n",
       "            })();\n",
       "            </script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "                <style>\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "                </style>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    },
    {
     "data": {
      "text/html": [
       "   <div id=\"RnbKc6\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"library\">\n",
       "       if(!window.letsPlotCallQueue) {\n",
       "           window.letsPlotCallQueue = [];\n",
       "       }; \n",
       "       window.letsPlotCall = function(f) {\n",
       "           window.letsPlotCallQueue.push(f);\n",
       "       };\n",
       "       (function() {\n",
       "           var script = document.createElement(\"script\");\n",
       "           script.type = \"text/javascript\";\n",
       "           script.src = \"https://cdn.jsdelivr.net/gh/JetBrains/lets-plot@v3.1.0/js-package/distr/lets-plot.min.js\";\n",
       "           script.onload = function() {\n",
       "               window.letsPlotCall = function(f) {f();};\n",
       "               window.letsPlotCallQueue.forEach(function(f) {f();});\n",
       "               window.letsPlotCallQueue = [];\n",
       "               \n",
       "               \n",
       "           };\n",
       "           script.onerror = function(event) {\n",
       "               window.letsPlotCall = function(f) {};\n",
       "               window.letsPlotCallQueue = [];\n",
       "               var div = document.createElement(\"div\");\n",
       "               div.style.color = 'darkred';\n",
       "               div.textContent = 'Error loading Lets-Plot JS';\n",
       "               document.getElementById(\"RnbKc6\").appendChild(div);\n",
       "           };\n",
       "           var e = document.getElementById(\"RnbKc6\");\n",
       "           e.appendChild(script);\n",
       "       })();\n",
       "   </script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%use multik\n",
    "%use dataframe\n",
    "%use lets-plot"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c5a97059-f45b-4255-9858-eed3e2894920",
   "metadata": {},
   "source": [
    "For creating a `Plot` object, we invoke the function `ggplot()`, which accepts a `Map<*, *>` and a generic aesthetic mapping."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "c683d484-905d-4ba5-bfc9-6bdc550f8d85",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"S86z0I\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Sin function on range 0..2𝛑\"\n",
       "},\n",
       "\"mapping\":{\n",
       "\"x\":\"x\",\n",
       "\"y\":\"y\"\n",
       "},\n",
       "\"data\":{\n",
       "\"x\":[0.0,0.06346651825433926,0.12693303650867852,0.1903995547630178,0.25386607301735703,0.3173325912716963,0.3807991095260356,0.4442656277803748,0.5077321460347141,0.5711986642890533,0.6346651825433925,0.6981317007977318,0.7615982190520711,0.8250647373064104,0.8885312555607496,0.9519977738150889,1.0154642920694281,1.0789308103237674,1.1423973285781066,1.2058638468324459,1.269330365086785,1.3327968833411243,1.3962634015954636,1.4597299198498028,1.5231964381041423,1.5866629563584815,1.6501294746128208,1.71359599286716,1.7770625111214993,1.8405290293758385,1.9039955476301778,1.967462065884517,2.0309285841388562,2.0943951023931957,2.1578616206475347,2.221328138901874,2.284794657156213,2.3482611754105527,2.4117276936648917,2.475194211919231,2.53866073017357,2.6021272484279097,2.6655937666822487,2.729060284936588,2.792526803190927,2.8559933214452666,2.9194598396996057,2.982926357953945,3.0463928762082846,3.1098593944626236,3.173325912716963,3.236792430971302,3.3002589492256416,3.3637254674799806,3.42719198573432,3.490658503988659,3.5541250222429985,3.6175915404973376,3.681058058751677,3.744524577006016,3.8079910952603555,3.8714576135146945,3.934924131769034,3.998390650023373,4.0618571682777125,4.1253236865320515,4.188790204786391,4.25225672304073,4.3157232412950695,4.3791897595494085,4.442656277803748,4.506122796058087,4.569589314312426,4.6330558325667655,4.696522350821105,4.759988869075444,4.823455387329783,4.886921905584122,4.950388423838462,5.013854942092801,5.07732146034714,5.14078797860148,5.204254496855819,5.267721015110158,5.331187533364497,5.394654051618837,5.458120569873176,5.521587088127515,5.585053606381854,5.648520124636194,5.711986642890533,5.775453161144872,5.838919679399211,5.902386197653551,5.96585271590789,6.029319234162229,6.092785752416569,6.156252270670908,6.219718788925247,6.283185307179586],\n",
       "\"y\":[0.0,0.0634239196565645,0.12659245357374926,0.18925124436041021,0.2511479871810792,0.31203344569848707,0.3716624556603276,0.42979491208917164,0.4861967361004687,0.5406408174555976,0.5929079290546404,0.6427876096865393,0.690079011482112,0.7345917086575333,0.7761464642917568,0.8145759520503357,0.8497254299495144,0.8814533634475821,0.9096319953545183,0.9341478602651067,0.9549022414440739,0.9718115683235417,0.984807753012208,0.9938384644612541,0.998867339183008,0.9998741276738751,0.9968547759519424,0.9898214418809327,0.9788024462147787,0.963842158559942,0.9450008187146685,0.9223542941045814,0.8959937742913359,0.8660254037844386,0.8325698546347714,0.795761840530832,0.7557495743542583,0.7126941713788628,0.6667690005162916,0.6181589862206052,0.5670598638627709,0.5136773915734063,0.4582265217274105,0.4009305354066136,0.3420201433256689,0.28173255684142967,0.2203105327865408,0.1580013959733499,0.09505604330418244,0.031727933498067656,-0.03172793349806786,-0.09505604330418263,-0.15800139597335008,-0.22031053278654056,-0.28173255684142984,-0.34202014332566866,-0.4009305354066138,-0.4582265217274103,-0.5136773915734064,-0.5670598638627706,-0.6181589862206053,-0.6667690005162915,-0.7126941713788629,-0.7557495743542582,-0.7957618405308321,-0.8325698546347713,-0.8660254037844388,-0.895993774291336,-0.9223542941045814,-0.9450008187146683,-0.9638421585599422,-0.9788024462147787,-0.9898214418809327,-0.9968547759519423,-0.9998741276738751,-0.998867339183008,-0.9938384644612541,-0.9848077530122081,-0.9718115683235417,-0.9549022414440739,-0.9341478602651068,-0.9096319953545182,-0.881453363447582,-0.8497254299495144,-0.8145759520503358,-0.7761464642917566,-0.7345917086575332,-0.690079011482112,-0.6427876096865396,-0.5929079290546402,-0.5406408174555976,-0.4861967361004688,-0.4297949120891719,-0.37166245566032724,-0.31203344569848707,-0.2511479871810794,-0.18925124436040974,-0.12659245357374904,-0.06342391965656452,-2.4492935982947064E-16]\n",
       "},\n",
       "\"ggsize\":{\n",
       "\"width\":650.0,\n",
       "\"height\":250.0\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"line\",\n",
       "\"data\":{\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"S86z0I\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val x = mk.linspace<Double>(0.0, 2.0 * kotlin.math.PI, 100)\n",
    "val y = mk.math.sin(x)\n",
    "\n",
    "val points = mapOf<String, Any>(\n",
    "    \"x\" to x.toList(),\n",
    "    \"y\" to y.toList()\n",
    ")\n",
    "\n",
    "ggplot(points) { x= \"x\" ; y = \"y\" } +\n",
    "    geomLine() +\n",
    "    ggtitle(\"Sin function on range 0..2𝛑\") +\n",
    "    ggsize(650, 250)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "0efc19e8-329a-49ca-b942-1eb08be5068d",
   "metadata": {},
   "source": [
    "In Lets-Plot, the main difference with python's Matplotlib, is the creation of the plot by **layers**. In Kotlin, thanks to the possibility to overload the `+` operator, we create the figure with a chain of additions on top of the `Plot` object.\n",
    "In the example below, we created\n",
    "- The plot providing a series of points, and the mapping of map's keys to plot axes.\n",
    "- The layer of the line.\n",
    "- A layer for the title\n",
    "- A layer for configuring the dimensions of the figure.\n",
    "\n",
    "This approach seems a little bit more expensive than with python:\n",
    "```python\n",
    "x = np.linspace(0, 2 * np.pi, 100)\n",
    "plt.plot(x, np.sin(x))\n",
    "```\n",
    "but the benefits of layers can be seen in more complicated examples.\n",
    "\n"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c0b9fc8f-a3a8-4f50-a9cf-3c001afbe0bc",
   "metadata": {},
   "source": [
    "```{note}\n",
    "Matplotlib encourages the use of the \"Object Oriented\" APIs, so the following code would be preferred:\n",
    "```python\n",
    "x = np.linspace(0, 2 * np.pi, 100)\n",
    "\n",
    "fig, ax = plt.subplots()\n",
    "ax.plot(x, np.sin(x))\n",
    "plt.show()\n",
    "```\n",
    "\n",
    "See [matplotlib blog](https://matplotlib.org/matplotblog/posts/pyplot-vs-object-oriented-interface/) for more information.\n",
    "\n",
    "```\n"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "3d40a4ed-fd40-4c28-a491-fceb2aab8134",
   "metadata": {},
   "source": [
    "## Lets-Plot Architecture"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6937bba0-1765-4d13-9177-7301431311ba",
   "metadata": {},
   "source": [
    "As already said, a plot is composed by one or more *Layers*. Each layer is responsible for creating the objects painted on the \"canvas\" and each one contains:\n",
    "- **Data**: the set of data specified for all layers, or one dataset per layer.\n",
    "- **Aesthetic Mapping**: describe how variables in the dataset are mapped to the visual properties of the layer.\n",
    "- **Geometric Object**: a geometric object that represents a particular type of chart.\n",
    "- **Statistical Transformation**: computes a statistical summary on the raw input data.\n",
    "- **Positional Adjustment**: method used to compute the final coordinates of geometry."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c04cc42d-e86a-4b3a-9fe6-6e908df89835",
   "metadata": {},
   "source": [
    "### Geometric Objects"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "621ddca2-6391-4ecc-936e-f411a380abaa",
   "metadata": {},
   "source": [
    "They are responsible for drawing in the plot. All the functions that are of the type `geomXxx()` create a new layer that draws the data. Every `geom` object has its own default parameters and behavior, see the [documentation](https://lets-plot.org/kotlin/-lets--plot--kotlin/org.jetbrains.letsPlot.geom/index.html) for understanding what the desired plot does or require.\n"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "eaff745d-2384-4ff2-af2e-50dee33dc71e",
   "metadata": {},
   "source": [
    "The `geom` package contains some `statXxx()` methods which also create a plot layer: sometimes is more natural to use `statXxx()` objects instead of `geomXxx()` to add a new plot layer."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "id": "e0ec55bf-390e-496e-90b6-d281489cf342",
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"u37oqC\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"pts\",\n",
       "\"fill\":\"cat\"\n",
       "},\n",
       "\"stat\":\"density\",\n",
       "\"alpha\":0.5,\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"density\",\n",
       "\"data\":{\n",
       "\"cat\":[\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"A\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\",\"B\"],\n",
       "\"..density..\":[0.008081795744251464,0.00833390226489257,0.00858166672258543,0.008824323361668511,0.009061121021287305,0.009291329279234366,0.009514244680578116,0.0097291969988559,0.00993555547570218,0.010132734983451748,0.01032020205452733,0.0104974807213178,0.010664158110788328,0.01081988973924482,0.010964404454497674,0.01109750897512086,0.011219091979561138,0.011329127701486936,0.011427678991938915,0.011514899813508218,0.011591037136868355,0.011656432215465378,0.011711521219959619,0.0117568352200446,0.011792999507469,0.01182073226038259,0.011840842555440014,0.011854227740351901,0.011861870185696415,0.011864833440724617,0.011864257823541044,0.011861355481353742,0.011857404961405886,0.011853745337673648,0.011851769942394183,0.011852919754937581,0.011858676503424308,0.011870555536793765,0.011890098526733964,0.011918866059980035,0.011958430181980284,0.012010366952820834,0.012076249075607181,0.01215763865624475,0.012256080151766525,0.012373093562055775,0.012510167917041933,0.012668755108246403,0.012850264109965598,0.013056055631444095,0.013287437237158117,0.013545658967843814,0.013831909490212355,0.014147312798441329,0.014492925485561359,0.014869734597814004,0.015278656079979415,0.015720533814602217,0.016196139253013712,0.016706171631095005,0.017251258757878626,0.017831958360372765,0.01844875996344266,0.019102087279217254,0.019792301076331023,0.020519702495380595,0.021284536773291812,0.022086997335871744,0.022927230214682032,0.023805338741525902,0.02472138847131064,0.0256754122818449,0.026667415597268117,0.027697381680307727,0.0287652769374289,0.029871056180199366,0.031014667785853683,0.03219605870011679,0.03341517922585783,0.03467198754209609,0.035966453899288764,0.03729856443870385,0.03866832458602441,0.040075761972152305,0.04152092883747778,0.04300390387965607,0.044524793509169595,0.04608373248165715,0.04768088388112144,0.04931643843368005,0.05099061313746238,0.05270364920054438,0.05445580928541159,0.05624737406530736,0.05807863810489281,0.05994990508487238,0.061861482397546894,0.06381367514758818,0.06580677959959673,0.06784107612115178,0.06991682167698583,0.0720342419365621,0.07419352306359703,0.07639480326188901,0.07863816415710499,0.08092362209885946,0.08325111947143805,0.0856205161047892,0.08803158087988891,0.09048398362421574,0.09297728739381433,0.09551094123824583,0.09808427354359495,0.10069648604661126,0.10334664861000917,0.10603369484493173,0.10875641866162805,0.11151347182351627,0.11430336257305182,0.11712445539022653,0.11997497193615744,0.12285299322512158,0.12575646305866167,0.12868319274504786,0.13163086711656452,0.13459705184584586,0.13757920205090723,0.14057467216669842,0.1435807270490391,0.14659455426474707,0.1496132775097744,0.1526339710852661,0.15565367534977498,0.15866941305449148,0.1616782064573439,0.16467709510131265,0.1676631541323536,0.17063351302302368,0.1735853745593463,0.17651603394073082,0.17942289783593787,0.18230350323228112,0.18515553591052544,0.18797684837439868,0.19076547706134905,0.1935196586602284,0.1962378453620738,0.198918718872132,0.20156120301483407,0.2041644747686142,0.20672797357436434,0.20925140876993584,0.2117347650135111,0.21417830557085657,0.2165825733554648,0.2189483896263476,0.22127685026574487,0.22356931957817547,0.22582742157300512,0.22805302871490127,0.23024824815007974,0.23241540544090136,0.23455702586697208,0.23667581337721846,0.23877462730413834,0.24085645697835215,0.24292439440832617,0.2449816052164177,0.24703129804784976,0.24907669269348115,0.25112098718997017,0.25316732418172067,0.2552187568475449,0.2572782147108584,0.2593484696651806,0.26143210255636085,0.26353147066907967,0.2656486764674782,0.26778553793810533,0.2699435608775308,0.27212391345691833,0.27432740338147865,0.27655445794411226,0.2788051072497346,0.2810789708599428,0.2810789708599428,0.28337524807701997,0.28569271205207164,0.28802970786467996,0.2903841546812592,0.2927535520567335,0.295134990399734,0.29752516557582287,0.29992039757676386,0.3023166531373156,0.3047095721349078,0.30709449756260704,0.30946650882252474,0.31182045804595576,0.31415100910854826,0.3164526789743683,0.3187198809722159,0.3209469695815413,0.3231282862841317,0.3252582060217343,0.32733118378924203,0.32934180088812787,0.33128481036560925,0.3331551811715558,0.3349481405773654,0.33665921441877644,0.3382842647476286,0.3398195245056224,0.3412616288658097,0.3426076429244001,0.3438550854660177,0.3450019485692371,0.3460467128654964,0.34698835831266256,0.34782637039405434,0.3485607417038844,0.3491919689302702,0.34972104529652176,0.35014944856973274,0.3504791247921992,0.3507124679352914,0.35085229571663246,0.35090182185931434,0.35086462510601146,0.35074461533089896,0.3505459971179701,0.3502732311954596,0.34993099413246737,0.34952413671549176,0.3490576414293439,0.3485365794689579,0.3479660677059503,0.3473512260266519,0.34669713544687963,0.34669713544687963,0.34600879739323886,0.34529109452149365,0.3445487534198602,0.34378630951931255,0.34300807450448123,0.3422181064878883,0.3414201831774716,0.34061777823297695,0.33981404097127516,0.3390117795443385,0.33821344767688105,0.3374211350138909,0.33663656109181056,0.3358610729112796,0.33509564605446307,0.33434088925633837,0.3335970523071824,0.3328640371331227,0.3321414118732626,0.3314284277457218,0.3307240384711833,0.33002692200134787,0.32933550428123054,0.3286479847586115,0.327962363341289,0.32727646849315156,0.3265879861535709,0.3258944891612467,0.3251934668634218,0.32448235459436725,0.3237585627131168,0.3230195048996308,0.3222626254207395,0.32148542509231093,0.32068548568190813,0.3198604925166472,0.31900825508378594,0.31812672543658027,0.31721401424488593,0.31626840435856174,0.315288361781671,0.3142725439864462,0.31321980552763123,0.31212920094980634,0.3109999850122429,0.3098316102873692,0.3086237222196713,0.3073761517614215,0.30608890572967284,0.30476215505510684,0.30339622111726094,0.3019915603820724,0.3005487475762795,0.2990684576487838,0.2975514467814014,0.2975514467814014,0.29599853272033305,0.2944105747050887,0.29278845327342296,0.29113305021906605,0.2894452289737267,0.28772581567606703,0.2859755811782738,0.2841952242256325,0.28238535602642134,0.28054648640872903,0.2786790117377844,0.2767832047424284,0.2748592063727927,0.2729070197835036,0.2709265065081812,0.2689173848620627,0.2668792305806621,0.264811479673882,0.2627134334472912,0.2605842656157624,0.25842303140964284,0.25622867855043985,0.2540000599518959,0.2517359479835588,0.24943505011770203,0.24709602576687353,0.2447175041085635,0.24229810268551638,0.23983644656513317,0.23733118783912996,0.23478102524512848,0.23218472369500953,0.2295411335005319,0.22684920909473985,0.22410802705785102,0.22131680326839884,0.2184749090141875,0.21558188591282232,0.21263745950795826,0.2096415514247135,0.20659428998562337,0.20349601920684787,0.20034730611282112,0.1971489463259065,0.193901967905689,0.19060763343008813,0.18726744032732287,0.18388311948375144,0.180456632167606,0.1769901653225135,0.17348612529737703,0.16994713009057885,0.16637600019654347,0.1627757481514183,0.1591495668819889,0.1555008169679517,0.15183301293235948,0.14814980867844896,0.14445498219322717,0.14075241963919613,0.13704609895548645,0.13334007308854393,0.12963845297045326,0.12594539036004457,0.12226506065824518,0.11860164580474912,0.11495931735809592,0.11134221985575961,0.10775445454491014,0.10420006356822016,0.10068301468252372,0.09720718658134228,0.0937763548853624,0.09039417885793963,0.08706418889565531,0.08378977483694054,0.08057417512485325,0.07742046685327343,0.07433155671915123,0.07131017289700117,0.06835885784564692,0.06547996205131253,0.06267563870554635,0.059947839311191346,0.057298310204706875,0.054728589978605476,0.052240007783626814,0.04983368248654121,0.047510522656154616,0.04527122734719398,0.043116287649288196,0.04104598896620609,0.03906041398888987,0.03715944632459081,0.03534277474357625,0.03360989800441103,0.03196013021868869,0.0303926067162798,0.028906290372646276,0.02749997836049529,0.026172309288989087,0.024921770694845195,0.023746706850907896,0.022645326859111956,0.02161571299615177,0.02065582928156283,0.019763530239292452,0.018936569825132567,0.01817261049358265,0.017469232378774593,0.016823942564993453,0.01623418442305189,0.015697346989306974,0.015210774364432354,0.014771775109178497,0.014377631614271143,0.01402560942132109,0.013712966471166498,0.0134369622554634,0.013194866846607136,0.012983969780244005,0.012801588763751537,0.012645078183171678,0.012511837380216106,0.012399318670171633,0.012305035070862993,0.012226567712325515,0.012161572896544324,0.012107788776572138,0.012063041624581515,0.012025251658972608,0.011992438401571815,0.011962725537241583,0.011934345249890968,0.011905642010937847,0.011875075798725588,0.011841224730230936,0.011802787089598896,0.011758582741579753,0.0117075539217906,0.011648765399839976,0.011581404015692975,0.011504777594164522,0.011418313247054241,0.011321555077117223,0.01121416130273867,0.011095900826783325,0.010966649277557177,0.01082638455408766,0.010675181911936307,0.010513208629447757,0.01034071829765723,0.010158044779976257,0.009965595890211714,0.00976384683941144,0.009553333503441902,0.00933464556407135,0.009108419576643888,0.008875332017182913,0.00863609236096246,0.008391436243246977,0.008142118751043877,0.007888907892371304,0.007632578286749655,0.007373905117423304,0.007113658382257218,0.006852597476381929,0.006591466135537223,0.006330987764747637,0.006071861172509858,0.005814756726144537,0.005560312939422236,0.005309133499071452,0.0050617847323727915,0.004818793513789309,0.004580645604524832,0.004347784415086361,0.004120610177388384,0.0038994795097107445,0.0036847053549342217,0.0034765572699487278,0.003275262041973922,0.0030810046057595914,0.0028939292342450075,0.0027141409742508908,0.0025417072981463017,0.0023766599421615685,0.002218996902091108,0.0020686845575248205,0.001925659896438226,0.0017898328129338813,0.0016610884521285744,0.0015392895775924193,0.0014242789383351853,0.0013158816140688941,0.0012139073193224656,0.001118152648912393,0.0010284032492519379,9.444359019821036E-4,8.660205084032106E-4,7.929219651511346E-4,7.249019234749106E-4,6.61720426312517E-4,6.031374191111954E-4,5.48914131983916E-4,4.98814332321666E-4,4.526054483833795E-4,4.100595656547921E-4,3.7095429889967357E-4,3.350735438202713E-4,3.0220811309843713E-4,2.721562623068154E-4,2.447241117647695E-4,2.1972597087170572E-4,1.969845717876995E-4,1.7633121955567494E-4,1.5760586587941386E-4,1.4065711379630024E-4,1.2534216042285392E-4,0.026916071969441225,0.02741623334277659,0.027917074431329257,0.028418538841543703,0.028920579684875408,0.02942315945984167,0.029926249903764773,0.030429831817872094,0.030933894869646913,0.03143843737652088,0.0319434660751496,0.03244899588062322,0.03295504964002963,0.03346165788480685,0.03396885858629526,0.03447669691882751,0.03498522503457556,0.035494501854210866,0.03600459287722551,0.036515570015514476,0.03702751145352816,0.03754050153797975,0.03805463069973023,0.038569995410083414,0.03908669817330522,0.03960484755673923,0.0401245582594315,0.04064595121970302,0.04116915376162284,0.04169429977984811,0.0422215299618054,0.04275099204570486,0.04328284111240217,0.04381723990866237,0.04435435919893627,0.04489437814234051,0.04543748469113677,0.045983876006646524,0.046533758888205226,0.047087350210469676,0.04764487736414156,0.0482065786949584,0.04877270393563951,0.0493435146253544,0.04991928451120579,0.05050029992619653,0.05108686013816654,0.05167927766425634,0.0522778785455651,0.05288300257683082,0.05349500348615921,0.05411424906007103,0.05474112120941856,0.055376015972036334,0.05601934344834213,0.056671527666482896,0.05733300637402528,0.0580042307536175,0.05868566506049997,0.05937778618019901,0.060081083105217814,0.060796056330017084,0.06152321716406481,0.06226308696322282,0.06301619628021944,0.06378308393543698,0.06456429600971018,0.06536038476128829,0.06617190746955544,0.06699942520852668,0.06784350155354235,0.06870470122496726,0.06958358867306046,0.07048072660851809,0.07139667448350272,0.07233198692825607,0.07328721214865162,0.07426289029027192,0.07525955177480186,0.07627771561470309,0.07731788771228543,0.07838055914941398,0.07946620447418741,0.08057527999099375,0.08170822206039657,0.08286544541532828,0.08404734150006118,0.08525427683840985,0.08648659143756326,0.087744597233885,0.08902857658692348,0.09033878082776868,0.09167542886775937,0.09303870587339232,0.09442876201311966,0.09584571128152289,0.09728963040614824,0.0987605578420549,0.10025849285887674,0.10178339472493121,0.10333518199261527,0.10491373188902128,0.10651887981536996,0.10815041895851092,0.10980810001736335,0.11149163104678358,0.11320067742092567,0.11493486191773418,0.11669376492575462,0.11847692477397738,0.12028383818494227,0.12211396085083095,0.12396670813175226,0.12584145587490247,0.1277375413527342,0.12965426431772767,0.13159088817079836,0.13354664123982557,0.1355207181642288,0.13751228138096896,0.13952046270681595,0.14154436501118872,0.1435830639733666,0.1456356099173777,0.14770102971740312,0.14977832876610062,0.15186649299784385,0.1539644909585131,0.15607127591314382,0.1581857879824641,0.16030695629912523,0.16243370117425157,0.16456493626481655,0.1666995707322943,0.16883651138303685,0.17097466478088344,0.17311293932265318,0.1752502472673428,0.1773855067101333,0.17951764349261026,0.1816455930410099,0.18376830212473358,0.18588473052789137,0.18799385262720034,0.19009465887017332,0.1921861571482086,0.1942673740598948,0.19633735606059616,0.19839517049516592,0.2004399065114394,0.2024706758529943,0.2044866135304947,0.20648687837179136,0.2084706534517948,0.2104371464039664,0.21238558961609946,0.21431524031385532,0.2162253805362769,0.2181153170082407,0.21998438091546915,0.221831927588374,0.223657336101553,0.2254600087962823,0.22723937073377887,0.22899486908737987,0.23072597248206864,0.23243217029000146,0.23411297189080993,0.23411297189080993,0.23576790590551355,0.23739651941283957,0.2389983771566407,0.24057306075290538,0.2421201679045832,0.24363931163210953,0.24513011952709302,0.24659223303615113,0.24802530678132897,0.24942900792295178,0.25080301557009993,0.25214702024322017,0.25346072339265685,0.2547438369761419,0.25599608309751826,0.2572171937081892,0.25840691037201735,0.2595649840936208,0.26069117520925733,0.2617852533387668,0.262846997396325,0.2638761956571147,0.2648726458763957,0.26583615545689016,0.26676654165989777,0.2676636318551051,0.2685272638036793,0.2693572859689295,0.2701535578485862,0.2709159503225887,0.2716443460101938,0.27233863963020905,0.2729987383582292,0.2736245621748977,0.27421604419942847,0.27477313100291495,0.2752957828962987,0.27578397418827605,0.27623769340888876,0.2766569434950531,0.2770417419348321,0.27739212086784226,0.27770812713979764,0.27798982230982694,0.2782372826098393,0.2784505988558577,0.2786298763118844,0.2787752345074835,0.27888680701087337,0.2789647411599039,0.2790091977538262,0.27902035070927783,0.278998386684343,0.27894350467496276,0.27885591558829687,0.27873584179793537,0.2785835166860531,0.2783991841777634,0.2781830982729942,0.2779355225812182,0.27765672986430656,0.2773470015926412,0.27700662751941696,0.27663590527780707,0.27623514000532534,0.27623514000532534,0.2758046439993458,0.2753447364072937,0.2748557429545362,0.27433799571248557,0.2737918329088423,0.273217598781341,0.27261564347573214,0.27198632298811437,0.2713299991510967,0.27064703966264886,0.26993781815586376,0.26920271430726167,0.2684421139806818,0.2676564094032559,0.26684599936944553,0.26601128946865804,0.2651526923315322,0.2642706278896203,0.26336552364288485,0.26243781492918045,0.2614879451897152,0.2605163662243645,0.2595235384306748,0.2585099310204102,0.25747602220759414,0.2564222993621608,0.255349259123555,0.25425740746891645,0.2531472597308364,0.25201934056008907,0.25087418382919724,0.24971233247321376,0.24853433826464763,0.24734076152005544,0.24613217073644575,0.24490914215628148,0.243672259260534,0.24242211218991006,0.24115929709505046,0.23988441541716896,0.23859807310126072,0.23730087974465428,0.23599344768429528,0.23467639102674437,0.2333503246254225,0.2320158630101497,0.23067361927448754,0.22932420392681427,0.22796822371142678,0.22660628040625796,0.22523896960405881,0.22386687948406753,0.22249058958131576,0.221110669560781,0.21972767800358828,0.21834216121240474,0.2169546520430361,0.2155656687690582,0.21417571398607266,0.21278527356188232,0.21139481563854093,0.21000478969184472,0.20861562565340638,0.20722773309998335,0.2058415005142467,0.20445729462064385,0.2030754597994842,0.20169631758180362,0.20032016622701718,0.1989472803847865,0.1975779108419733,0.1975779108419733,0.19621228435498592,0.19485060356728323,0.19349304701126527,0.19213976919328077,0.19079090075999083,0.1894465487438855,0.18810679688532173,0.186771706028078,0.18544131458507163,0.18411563907058193,0.18279467469506674,0.18147839601843707,0.18016675765748819,0.17885969504305035,0.17755712522234243,0.1762589477019709,0.17496504532700802,0.17367528519163522,0.17238951957690418,0.17110758691128558,0.16982931274982072,0.1685545107678625,0.16728298376559445,0.166014524679738,0.16474891759909738,0.16348593878084933,0.1622253576647487,0.16096693788269462,0.15971043826137607,0.1584556138159948,0.15720221673332607,0.15594999734264656,0.1546987050733048,0.15344808939794521,0.15219790076061604,0.1509478914891879,0.14969781669168503,0.1484474351362831,0.14719651011485171,0.1459448102900206,0.1446921105258169,0.1434381927019661,0.14218284651196558,0.14092587024502723,0.13966707155194624,0.1384062681948963,0.13714328878105767,0.1358779734798831,0.13461017472367615,0.13333975789101546,0.13206660197239656,0.1307906002173006,0.12951166076171527,0.12822970723495833,0.12694467934446674,0.1256565334370351,0.12436524303481297,0.12307079934420152,0.12177321173563406,0.120472508192089,0.11916873572405677,0.1178619607485814,0.1165522694299208,0.11523976797931267,0.11392458291130687,0.11260686125412951,0.11128677071156998,0.109964499773949,0.1086402577758167,0.10731427489815147,0.10598680211298958,0.1046581110685963,0.10332849391350293,0.10199826305797831,0.1006677508717658,0.09933730931720895,0.0980073095171993,0.09667814125770999,0.09535021242501986,0.09402394837809457,0.0926997912569504,0.09137819922820169,0.09005964566936134,0.08874461829383445,0.08743361821891028,0.08612715897941023,0.0848257654899917,0.0835299729594337,0.08224032576053424,0.0809573762595312,0.07968168360921815,0.07841381251015124,0.07715433194454369,0.07590381388760889,0.07466283200124302,0.07343196031503509,0.07221177189965028,0.07100283753765294,0.06980572439682314,0.06862099471096593,0.0674492044731236,0.06629090214597971,0.06514662739408357,0.06401690984233295,0.06290226786493565,0.061803207408819914,0.06072022085518911,0.05965378592262504,0.05860436461482328,0.057572402215718126,0.056558326334408535,0.05556254600194332,0.05458545082166897,0.053627410174480195,0.0526887724799568,0.05176986451401816,0.05087099078338133,0.04999243295677679,0.04913444935256053,0.04829727448206099,0.047481118647721594,0.046686167594847505,0.045912582215533335,0.04516049830315039,0.04443002635559818,0.04372125142538358,0.04303423301448091,0.042369005011847705,0.04172557567142235,0.04110392762841795,0.04050401795173961,0.039925778230400895,0.0393691146918905,0.03883390835054277,0.03832001518409453,0.037827266336764254,0.03735546834736084,0.03690440340112356,0.036473829604200814,0.03606348127989547,0.035673069286035294,0.03530228135306143,0.03495078244266668,0.03461821512705366,0.0343041999891162,0.03400833604407341,0.03373020118330245,0.03346935264131663,0.03322532748702075,0.03299764314054033,0.03278579791706317,0.03258927159924908,0.032407526039853335,0.032240005796269615,0.03208613879872822,0.03194533705388279,0.031816997385482604,0.03170050221375894,0.03159522037504974,0.031500507983049986,0.03141570933290406,0.03134015784915333,0.03127317707831719,0.031214081726621296,0.031162178743094508,0.03111676844793749,0.03107714570572532,0.0310426011426443,0.031012422406585003,0.03098589546852079,0.030962305963198187,0.030940940566756045,0.030921088408478455,0.030902042513474753,0.030883101272674768,0.03086356993613052,0.030842762125232234,0.030820001359080796,0.030794622589913424,0.030765973742159933,0.03073341724941479,0.030696331583351194,0.030654112768378622,0.030606175875658535,0.03055195648994735,0.03049091214263213,0.030422523704266107,0.03034629672989883,0.030261762750530975,0.030168480504106726,0.030066037099588713,0.029954049107840577,0.029832163573269517,0.02970005894045688,0.02955744589032445,0.029404068080748292,0.029239702786938025,0.02906416143734363,0.028877290041332913,0.028678969505396626,0.028469115835181157,0.028247680221217483,0.028014649006805375,0.02777004353711936,0.02751391988922298,0.0272463684833074,0.02696751357610182,0.026677512638035555],\n",
       "\"..quantile..\":[0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0],\n",
       "\"pts\":[-3.372993589836054,-3.3588630952189615,-3.3447326006018696,-3.3306021059847772,-3.316471611367685,-3.3023411167505925,-3.2882106221335006,-3.274080127516408,-3.259949632899316,-3.245819138282224,-3.2316886436651315,-3.217558149048039,-3.203427654430947,-3.189297159813855,-3.1751666651967625,-3.16103617057967,-3.146905675962578,-3.132775181345486,-3.1186446867283935,-3.104514192111301,-3.090383697494209,-3.076253202877117,-3.0621227082600244,-3.0479922136429325,-3.03386171902584,-3.0197312244087477,-3.0056007297916554,-2.9914702351745635,-2.977339740557471,-2.9632092459403787,-2.9490787513232863,-2.9349482567061944,-2.920817762089102,-2.9066872674720097,-2.8925567728549177,-2.8784262782378254,-2.864295783620733,-2.850165289003641,-2.8360347943865487,-2.8219042997694563,-2.8077738051523644,-2.793643310535272,-2.7795128159181797,-2.7653823213010873,-2.751251826683995,-2.737121332066903,-2.7229908374498106,-2.7088603428327183,-2.6947298482156263,-2.680599353598534,-2.6664688589814416,-2.6523383643643497,-2.6382078697472573,-2.624077375130165,-2.609946880513073,-2.5958163858959806,-2.5816858912788883,-2.567555396661796,-2.5534249020447035,-2.5392944074276116,-2.525163912810519,-2.511033418193427,-2.496902923576335,-2.4827724289592425,-2.46864193434215,-2.4545114397250583,-2.440380945107966,-2.4262504504908735,-2.4121199558737816,-2.397989461256689,-2.383858966639597,-2.3697284720225045,-2.355597977405412,-2.34146748278832,-2.327336988171228,-2.3132064935541354,-2.2990759989370435,-2.284945504319951,-2.2708150097028588,-2.256684515085767,-2.2425540204686745,-2.228423525851582,-2.21429303123449,-2.2001625366173974,-2.1860320420003054,-2.171901547383213,-2.1577710527661207,-2.1436405581490288,-2.1295100635319364,-2.115379568914844,-2.101249074297752,-2.0871185796806597,-2.0729880850635674,-2.0588575904464754,-2.044727095829383,-2.0305966012122907,-2.0164661065951988,-2.002335611978106,-1.988205117361014,-1.9740746227439216,-1.9599441281268295,-1.9458136335097374,-1.931683138892645,-1.9175526442755528,-1.9034221496584605,-1.8892916550413683,-1.875161160424276,-1.8610306658071838,-1.8469001711900916,-1.8327696765729993,-1.8186391819559071,-1.8045086873388148,-1.7903781927217226,-1.7762476981046302,-1.762117203487538,-1.747986708870446,-1.7338562142533536,-1.7197257196362614,-1.705595225019169,-1.691464730402077,-1.6773342357849845,-1.6632037411678924,-1.6490732465508002,-1.6349427519337079,-1.6208122573166157,-1.6066817626995233,-1.5925512680824312,-1.5784207734653388,-1.5642902788482467,-1.5501597842311545,-1.5360292896140622,-1.52189879499697,-1.5077683003798776,-1.4936378057627855,-1.4795073111456931,-1.465376816528601,-1.4512463219115088,-1.4371158272944164,-1.4229853326773243,-1.408854838060232,-1.3947243434431398,-1.3805938488260474,-1.366463354208955,-1.3523328595918631,-1.3382023649747707,-1.3240718703576784,-1.3099413757405864,-1.295810881123494,-1.2816803865064017,-1.2675498918893093,-1.2534193972722174,-1.239288902655125,-1.2251584080380327,-1.2110279134209407,-1.1968974188038484,-1.182766924186756,-1.1686364295696636,-1.1545059349525717,-1.1403754403354793,-1.126244945718387,-1.112114451101295,-1.0979839564842027,-1.0838534618671103,-1.069722967250018,-1.055592472632926,-1.0414619780158336,-1.0273314833987413,-1.0132009887816493,-0.999070494164557,-0.9849399995474646,-0.9708095049303722,-0.9566790103132803,-0.9425485156961879,-0.9284180210790955,-0.9142875264620036,-0.9001570318449112,-0.8860265372278189,-0.8718960426107265,-0.8577655479936346,-0.8436350533765422,-0.8295045587594498,-0.8153740641423579,-0.8012435695252655,-0.7871130749081732,-0.7729825802910808,-0.7729825802910808,-0.7588520856739889,-0.7447215910568965,-0.7305910964398041,-0.7164606018227122,-0.7023301072056198,-0.6881996125885275,-0.6740691179714351,-0.6599386233543432,-0.6458081287372508,-0.6316776341201584,-0.6175471395030665,-0.6034166448859741,-0.5892861502688818,-0.5751556556517894,-0.5610251610346975,-0.5468946664176051,-0.5327641718005127,-0.5186336771834208,-0.5045031825663284,-0.49037268794923605,-0.4762421933321437,-0.46211169871505176,-0.4479812040979594,-0.433850709480867,-0.4197202148637751,-0.4055897202466827,-0.39145922562959035,-0.377328731012498,-0.36319823639540605,-0.3490677417783137,-0.3349372471612213,-0.3208067525441294,-0.306676257927037,-0.29254576330994464,-0.27841526869285227,-0.26428477407576034,-0.25015427945866797,-0.2360237848415756,-0.22189329022448367,-0.2077627956073913,-0.19363230099029893,-0.17950180637320656,-0.16537131175611464,-0.15124081713902227,-0.1371103225219299,-0.12297982790483797,-0.1088493332877456,-0.09471883867065323,-0.08058834405356086,-0.06645784943646893,-0.05232735481937656,-0.03819686020228419,-0.024066365585192262,-0.024066365585192262,-0.009935870968099891,0.004194623648992479,0.01832511826608485,0.032455612883176777,0.04658610750026915,0.06071660211736152,0.07484709673445344,0.08897759135154582,0.10310808596863819,0.11723858058573056,0.13136907520282248,0.14549956981991485,0.15963006443700722,0.17376055905409915,0.18789105367119152,0.2020215482882839,0.21615204290537626,0.2302825375224682,0.24441303213956056,0.25854352675665293,0.27267402137374486,0.2868045159908372,0.3009350106079296,0.31506550522502197,0.3291959998421139,0.34332649445920627,0.35745698907629864,0.37158748369339056,0.38571797831048293,0.3998484729275753,0.4139789675446677,0.4281094621617596,0.442239956778852,0.45637045139594434,0.47050094601303627,0.48463144063012864,0.498761935247221,0.5128924298643134,0.5270229244814053,0.5411534190984977,0.55528391371559,0.569414408332682,0.5835449029497743,0.5976753975668667,0.6118058921839591,0.625936386801051,0.6400668814181438,0.6541973760352358,0.6683278706523277,0.6824583652694205,0.6965888598865124,0.7107193545036044,0.7248498491206972,0.7389803437377891,0.753110838354881,0.753110838354881,0.7672413329719738,0.7813718275890658,0.7955023222061577,0.8096328168232505,0.8237633114403424,0.8378938060574352,0.8520243006745272,0.8661547952916191,0.8802852899087119,0.8944157845258038,0.9085462791428958,0.9226767737599886,0.9368072683770805,0.9509377629941724,0.9650682576112652,0.9791987522283572,0.9933292468454491,1.007459741462542,1.0215902360796338,1.0357207306967267,1.0498512253138186,1.0639817199309105,1.0781122145480033,1.0922427091650952,1.1063732037821872,1.12050369839928,1.134634193016372,1.1487646876334638,1.1628951822505567,1.1770256768676486,1.1911561714847405,1.2052866661018333,1.2194171607189253,1.233547655336018,1.24767814995311,1.261808644570202,1.2759391391872947,1.2900696338043867,1.3042001284214786,1.3183306230385714,1.3324611176556633,1.3465916122727553,1.360722106889848,1.37485260150694,1.388983096124032,1.4031135907411247,1.4172440853582167,1.4313745799753095,1.4455050745924014,1.4596355692094933,1.4737660638265861,1.487896558443678,1.50202705306077,1.5161575476778628,1.5302880422949547,1.5444185369120467,1.5585490315291395,1.5726795261462314,1.5868100207633233,1.6009405153804162,1.615071009997508,1.629201504614601,1.6433319992316928,1.6574624938487847,1.6715929884658776,1.6857234830829695,1.6998539777000614,1.7139844723171542,1.7281149669342462,1.742245461551338,1.756375956168431,1.7705064507855228,1.7846369454026147,1.7987674400197076,1.8128979346367995,1.8270284292538923,1.8411589238709842,1.8552894184880762,1.869419913105169,1.883550407722261,1.8976809023393528,1.9118113969564456,1.9259418915735376,1.9400723861906295,1.9542028808077223,1.9683333754248142,1.9824638700419062,1.996594364658999,2.010724859276091,2.0248553538931837,2.0389858485102756,2.0531163431273676,2.0672468377444604,2.0813773323615523,2.0955078269786442,2.109638321595737,2.123768816212829,2.137899310829921,2.1520298054470137,2.1661603000641056,2.1802907946811976,2.1944212892982904,2.2085517839153823,2.222682278532475,2.236812773149567,2.250943267766659,2.265073762383752,2.2792042570008437,2.2933347516179357,2.3074652462350285,2.3215957408521204,2.3357262354692123,2.349856730086305,2.363987224703397,2.378117719320489,2.392248213937582,2.4063787085546737,2.4205092031717665,2.4346396977888585,2.4487701924059504,2.462900687023043,2.477031181640135,2.491161676257227,2.50529217087432,2.519422665491412,2.5335531601085037,2.5476836547255965,2.5618141493426885,2.5759446439597804,2.590075138576873,2.604205633193965,2.618336127811058,2.63246662242815,2.646597117045242,2.6607276116623346,2.6748581062794266,2.6889886008965185,2.7031190955136113,2.717249590130703,2.731380084747795,2.745510579364888,2.75964107398198,2.773771568599072,2.7879020632161646,2.8020325578332566,2.8161630524503494,2.8302935470674413,2.844424041684533,2.858554536301626,2.872685030918718,2.88681552553581,2.9009460201529027,2.9150765147699946,2.9292070093870866,2.9433375040041794,2.9574679986212713,2.9715984932383632,2.985728987855456,2.999859482472548,3.013989977089641,3.0281204717067327,3.0422509663238246,3.0563814609409174,3.0705119555580094,3.0846424501751013,3.098772944792194,3.112903439409286,3.127033934026378,3.141164428643471,3.1552949232605627,3.1694254178776546,3.1835559124947475,3.1976864071118394,3.211816901728932,3.225947396346024,3.240077890963116,3.254208385580209,3.268338880197301,3.2824693748143927,3.2965998694314855,3.3107303640485775,3.3248608586656694,3.338991353282762,3.353121847899854,3.367252342516946,3.381382837134039,3.395513331751131,3.4096438263682236,3.4237743209853155,3.4379048156024075,3.4520353102195003,3.466165804836592,3.480296299453684,3.494426794070777,3.508557288687869,3.522687783304961,3.5368182779220536,3.5509487725391455,3.5650792671562375,3.5792097617733303,3.593340256390422,3.607470751007515,3.621601245624607,3.635731740241699,3.6498622348587917,3.6639927294758836,3.6781232240929755,3.6922537187100684,3.7063842133271603,3.720514707944252,3.734645202561345,3.748775697178437,3.762906191795529,3.7770366864126217,3.7911671810297136,3.8052976756468064,3.8194281702638984,3.8335586648809903,3.847689159498083,-3.372993589836054,-3.3588630952189615,-3.3447326006018696,-3.3306021059847772,-3.316471611367685,-3.3023411167505925,-3.2882106221335006,-3.274080127516408,-3.259949632899316,-3.245819138282224,-3.2316886436651315,-3.217558149048039,-3.203427654430947,-3.189297159813855,-3.1751666651967625,-3.16103617057967,-3.146905675962578,-3.132775181345486,-3.1186446867283935,-3.104514192111301,-3.090383697494209,-3.076253202877117,-3.0621227082600244,-3.0479922136429325,-3.03386171902584,-3.0197312244087477,-3.0056007297916554,-2.9914702351745635,-2.977339740557471,-2.9632092459403787,-2.9490787513232863,-2.9349482567061944,-2.920817762089102,-2.9066872674720097,-2.8925567728549177,-2.8784262782378254,-2.864295783620733,-2.850165289003641,-2.8360347943865487,-2.8219042997694563,-2.8077738051523644,-2.793643310535272,-2.7795128159181797,-2.7653823213010873,-2.751251826683995,-2.737121332066903,-2.7229908374498106,-2.7088603428327183,-2.6947298482156263,-2.680599353598534,-2.6664688589814416,-2.6523383643643497,-2.6382078697472573,-2.624077375130165,-2.609946880513073,-2.5958163858959806,-2.5816858912788883,-2.567555396661796,-2.5534249020447035,-2.5392944074276116,-2.525163912810519,-2.511033418193427,-2.496902923576335,-2.4827724289592425,-2.46864193434215,-2.4545114397250583,-2.440380945107966,-2.4262504504908735,-2.4121199558737816,-2.397989461256689,-2.383858966639597,-2.3697284720225045,-2.355597977405412,-2.34146748278832,-2.327336988171228,-2.3132064935541354,-2.2990759989370435,-2.284945504319951,-2.2708150097028588,-2.256684515085767,-2.2425540204686745,-2.228423525851582,-2.21429303123449,-2.2001625366173974,-2.1860320420003054,-2.171901547383213,-2.1577710527661207,-2.1436405581490288,-2.1295100635319364,-2.115379568914844,-2.101249074297752,-2.0871185796806597,-2.0729880850635674,-2.0588575904464754,-2.044727095829383,-2.0305966012122907,-2.0164661065951988,-2.002335611978106,-1.988205117361014,-1.9740746227439216,-1.9599441281268295,-1.9458136335097374,-1.931683138892645,-1.9175526442755528,-1.9034221496584605,-1.8892916550413683,-1.875161160424276,-1.8610306658071838,-1.8469001711900916,-1.8327696765729993,-1.8186391819559071,-1.8045086873388148,-1.7903781927217226,-1.7762476981046302,-1.762117203487538,-1.747986708870446,-1.7338562142533536,-1.7197257196362614,-1.705595225019169,-1.691464730402077,-1.6773342357849845,-1.6632037411678924,-1.6490732465508002,-1.6349427519337079,-1.6208122573166157,-1.6066817626995233,-1.5925512680824312,-1.5784207734653388,-1.5642902788482467,-1.5501597842311545,-1.5360292896140622,-1.52189879499697,-1.5077683003798776,-1.4936378057627855,-1.4795073111456931,-1.465376816528601,-1.4512463219115088,-1.4371158272944164,-1.4229853326773243,-1.408854838060232,-1.3947243434431398,-1.3805938488260474,-1.366463354208955,-1.3523328595918631,-1.3382023649747707,-1.3240718703576784,-1.3099413757405864,-1.295810881123494,-1.2816803865064017,-1.2675498918893093,-1.2534193972722174,-1.239288902655125,-1.2251584080380327,-1.2110279134209407,-1.1968974188038484,-1.182766924186756,-1.1686364295696636,-1.1545059349525717,-1.1403754403354793,-1.126244945718387,-1.112114451101295,-1.0979839564842027,-1.0838534618671103,-1.069722967250018,-1.055592472632926,-1.0414619780158336,-1.0273314833987413,-1.0132009887816493,-1.0132009887816493,-0.999070494164557,-0.9849399995474646,-0.9708095049303722,-0.9566790103132803,-0.9425485156961879,-0.9284180210790955,-0.9142875264620036,-0.9001570318449112,-0.8860265372278189,-0.8718960426107265,-0.8577655479936346,-0.8436350533765422,-0.8295045587594498,-0.8153740641423579,-0.8012435695252655,-0.7871130749081732,-0.7729825802910808,-0.7588520856739889,-0.7447215910568965,-0.7305910964398041,-0.7164606018227122,-0.7023301072056198,-0.6881996125885275,-0.6740691179714351,-0.6599386233543432,-0.6458081287372508,-0.6316776341201584,-0.6175471395030665,-0.6034166448859741,-0.5892861502688818,-0.5751556556517894,-0.5610251610346975,-0.5468946664176051,-0.5327641718005127,-0.5186336771834208,-0.5045031825663284,-0.49037268794923605,-0.4762421933321437,-0.46211169871505176,-0.4479812040979594,-0.433850709480867,-0.4197202148637751,-0.4055897202466827,-0.39145922562959035,-0.377328731012498,-0.36319823639540605,-0.3490677417783137,-0.3349372471612213,-0.3208067525441294,-0.306676257927037,-0.29254576330994464,-0.27841526869285227,-0.26428477407576034,-0.25015427945866797,-0.2360237848415756,-0.22189329022448367,-0.2077627956073913,-0.19363230099029893,-0.17950180637320656,-0.16537131175611464,-0.15124081713902227,-0.1371103225219299,-0.12297982790483797,-0.1088493332877456,-0.09471883867065323,-0.09471883867065323,-0.08058834405356086,-0.06645784943646893,-0.05232735481937656,-0.03819686020228419,-0.024066365585192262,-0.009935870968099891,0.004194623648992479,0.01832511826608485,0.032455612883176777,0.04658610750026915,0.06071660211736152,0.07484709673445344,0.08897759135154582,0.10310808596863819,0.11723858058573056,0.13136907520282248,0.14549956981991485,0.15963006443700722,0.17376055905409915,0.18789105367119152,0.2020215482882839,0.21615204290537626,0.2302825375224682,0.24441303213956056,0.25854352675665293,0.27267402137374486,0.2868045159908372,0.3009350106079296,0.31506550522502197,0.3291959998421139,0.34332649445920627,0.35745698907629864,0.37158748369339056,0.38571797831048293,0.3998484729275753,0.4139789675446677,0.4281094621617596,0.442239956778852,0.45637045139594434,0.47050094601303627,0.48463144063012864,0.498761935247221,0.5128924298643134,0.5270229244814053,0.5411534190984977,0.55528391371559,0.569414408332682,0.5835449029497743,0.5976753975668667,0.6118058921839591,0.625936386801051,0.6400668814181438,0.6541973760352358,0.6683278706523277,0.6824583652694205,0.6965888598865124,0.7107193545036044,0.7248498491206972,0.7389803437377891,0.753110838354881,0.7672413329719738,0.7813718275890658,0.7955023222061577,0.8096328168232505,0.8237633114403424,0.8378938060574352,0.8520243006745272,0.8661547952916191,0.8802852899087119,0.8944157845258038,0.9085462791428958,0.9085462791428958,0.9226767737599886,0.9368072683770805,0.9509377629941724,0.9650682576112652,0.9791987522283572,0.9933292468454491,1.007459741462542,1.0215902360796338,1.0357207306967267,1.0498512253138186,1.0639817199309105,1.0781122145480033,1.0922427091650952,1.1063732037821872,1.12050369839928,1.134634193016372,1.1487646876334638,1.1628951822505567,1.1770256768676486,1.1911561714847405,1.2052866661018333,1.2194171607189253,1.233547655336018,1.24767814995311,1.261808644570202,1.2759391391872947,1.2900696338043867,1.3042001284214786,1.3183306230385714,1.3324611176556633,1.3465916122727553,1.360722106889848,1.37485260150694,1.388983096124032,1.4031135907411247,1.4172440853582167,1.4313745799753095,1.4455050745924014,1.4596355692094933,1.4737660638265861,1.487896558443678,1.50202705306077,1.5161575476778628,1.5302880422949547,1.5444185369120467,1.5585490315291395,1.5726795261462314,1.5868100207633233,1.6009405153804162,1.615071009997508,1.629201504614601,1.6433319992316928,1.6574624938487847,1.6715929884658776,1.6857234830829695,1.6998539777000614,1.7139844723171542,1.7281149669342462,1.742245461551338,1.756375956168431,1.7705064507855228,1.7846369454026147,1.7987674400197076,1.8128979346367995,1.8270284292538923,1.8411589238709842,1.8552894184880762,1.869419913105169,1.883550407722261,1.8976809023393528,1.9118113969564456,1.9259418915735376,1.9400723861906295,1.9542028808077223,1.9683333754248142,1.9824638700419062,1.996594364658999,2.010724859276091,2.0248553538931837,2.0389858485102756,2.0531163431273676,2.0672468377444604,2.0813773323615523,2.0955078269786442,2.109638321595737,2.123768816212829,2.137899310829921,2.1520298054470137,2.1661603000641056,2.1802907946811976,2.1944212892982904,2.2085517839153823,2.222682278532475,2.236812773149567,2.250943267766659,2.265073762383752,2.2792042570008437,2.2933347516179357,2.3074652462350285,2.3215957408521204,2.3357262354692123,2.349856730086305,2.363987224703397,2.378117719320489,2.392248213937582,2.4063787085546737,2.4205092031717665,2.4346396977888585,2.4487701924059504,2.462900687023043,2.477031181640135,2.491161676257227,2.50529217087432,2.519422665491412,2.5335531601085037,2.5476836547255965,2.5618141493426885,2.5759446439597804,2.590075138576873,2.604205633193965,2.618336127811058,2.63246662242815,2.646597117045242,2.6607276116623346,2.6748581062794266,2.6889886008965185,2.7031190955136113,2.717249590130703,2.731380084747795,2.745510579364888,2.75964107398198,2.773771568599072,2.7879020632161646,2.8020325578332566,2.8161630524503494,2.8302935470674413,2.844424041684533,2.858554536301626,2.872685030918718,2.88681552553581,2.9009460201529027,2.9150765147699946,2.9292070093870866,2.9433375040041794,2.9574679986212713,2.9715984932383632,2.985728987855456,2.999859482472548,3.013989977089641,3.0281204717067327,3.0422509663238246,3.0563814609409174,3.0705119555580094,3.0846424501751013,3.098772944792194,3.112903439409286,3.127033934026378,3.141164428643471,3.1552949232605627,3.1694254178776546,3.1835559124947475,3.1976864071118394,3.211816901728932,3.225947396346024,3.240077890963116,3.254208385580209,3.268338880197301,3.2824693748143927,3.2965998694314855,3.3107303640485775,3.3248608586656694,3.338991353282762,3.353121847899854,3.367252342516946,3.381382837134039,3.395513331751131,3.4096438263682236,3.4237743209853155,3.4379048156024075,3.4520353102195003,3.466165804836592,3.480296299453684,3.494426794070777,3.508557288687869,3.522687783304961,3.5368182779220536,3.5509487725391455,3.5650792671562375,3.5792097617733303,3.593340256390422,3.607470751007515,3.621601245624607,3.635731740241699,3.6498622348587917,3.6639927294758836,3.6781232240929755,3.6922537187100684,3.7063842133271603,3.720514707944252,3.734645202561345,3.748775697178437,3.762906191795529,3.7770366864126217,3.7911671810297136,3.8052976756468064,3.8194281702638984,3.8335586648809903,3.847689159498083]\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"u37oqC\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val rand = java.util.Random(123)\n",
    "val dataset = mapOf(\n",
    "    \"pts\" to List(100) { rand.nextGaussian() } + List(100) { 1.5 * rand.nextGaussian() },\n",
    "    \"cat\" to List(100) { \"A\" } + List(100) { \"B\" }\n",
    ")\n",
    "val p = ggplot(dataset)\n",
    "\n",
    "p + statDensity(alpha = 0.5) { x=\"pts\" ; fill=\"cat\" }"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "eb1bc06d-66b8-45a2-bb44-a16bb9abefbe",
   "metadata": {},
   "source": [
    "#### `stat`"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "cb9f4c13-f8b1-430e-ac0c-a6c6a5d11eec",
   "metadata": {},
   "source": [
    "`stat` can be added as an argument to a geometric object to define statistical transformation. The [`Stat`](https://lets-plot.org/kotlin/-lets--plot--kotlin/org.jetbrains.letsPlot/-stat/index.html) object contains all the statistical transformations that can be applied to a dataset, and it can be used like `geomXxx(stat = Stat.identity)`. \n",
    "\n",
    "We can apply a statistical transformation like `bin`, `density`, `count`, `smooth` and more."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "d1a9166a-acf4-47df-b7ba-1771e6904a64",
   "metadata": {
    "tags": []
   },
   "source": [
    "#### Position"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "d0c8c47a-64f6-4d02-9858-75c3b1700cb6",
   "metadata": {},
   "source": [
    "It's possible to adjust the position of data, especially in all those cases where data overlaps.\n",
    "\n",
    "We also introduce `ggbunch` that let us draw multiple plots in the same figure.\n",
    "\n",
    "Consider this dataset and it's corresponding bar plot:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "id": "9cc237ee-30e3-4e32-b7d3-6e48d380c41f",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"My7Mfo\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"v\",\n",
       "\"fill\":\"@as_discrete@c\"\n",
       "},\n",
       "\"stat\":\"count\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"fill\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"c\"\n",
       "}\n",
       "}]\n",
       "},\n",
       "\"data\":{\n",
       "\"v\":[4.0,3.0,1.0,2.0,0.0,4.0,2.0,0.0,3.0,1.0],\n",
       "\"..count..\":[14.0,10.0,6.0,12.0,6.0,18.0,9.0,6.0,8.0,11.0],\n",
       "\"@as_discrete@c\":[0.0,0.0,0.0,0.0,0.0,1.0,1.0,1.0,1.0,1.0]\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"My7Mfo\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 4,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val data = mapOf(\n",
    "    \"v\" to List(100) { rand.nextInt(5) },\n",
    "    \"c\" to List(100) { rand.nextInt(2) }\n",
    ")\n",
    "\n",
    "val p0 = ggplot(data) +\n",
    "    geomBar(alpha = 0.8) { x = \"v\"; fill=asDiscrete(\"c\") }\n",
    "p0"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "7615367c-83a0-4a31-84df-4bb98d5ace73",
   "metadata": {},
   "source": [
    "We can now set the position of the data to better visualize data:"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "id": "ebf4efe4-4c8a-4c87-95d6-9aa318bf0510",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"bnW1dg\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"kind\":\"ggbunch\",\n",
       "\"items\":[{\n",
       "\"x\":0,\n",
       "\"width\":500,\n",
       "\"y\":0,\n",
       "\"feature_spec\":{\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"v\",\n",
       "\"fill\":\"@as_discrete@c\"\n",
       "},\n",
       "\"stat\":\"count\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"fill\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"c\"\n",
       "}\n",
       "}]\n",
       "},\n",
       "\"data\":{\n",
       "\"v\":[4.0,3.0,1.0,2.0,0.0,4.0,2.0,0.0,3.0,1.0],\n",
       "\"..count..\":[14.0,10.0,6.0,12.0,6.0,18.0,9.0,6.0,8.0,11.0],\n",
       "\"@as_discrete@c\":[0.0,0.0,0.0,0.0,0.0,1.0,1.0,1.0,1.0,1.0]\n",
       "}\n",
       "}],\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Without Position\"\n",
       "},\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[]\n",
       "},\n",
       "\"height\":250\n",
       "},{\n",
       "\"x\":500,\n",
       "\"width\":500,\n",
       "\"y\":0,\n",
       "\"feature_spec\":{\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"v\",\n",
       "\"fill\":\"@as_discrete@c\"\n",
       "},\n",
       "\"stat\":\"count\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":{\n",
       "\"name\":\"dodge\",\n",
       "\"width\":0.5\n",
       "},\n",
       "\"geom\":\"bar\",\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"fill\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"c\"\n",
       "}\n",
       "}]\n",
       "},\n",
       "\"data\":{\n",
       "\"v\":[4.0,3.0,1.0,2.0,0.0,4.0,2.0,0.0,3.0,1.0],\n",
       "\"..count..\":[14.0,10.0,6.0,12.0,6.0,18.0,9.0,6.0,8.0,11.0],\n",
       "\"@as_discrete@c\":[0.0,0.0,0.0,0.0,0.0,1.0,1.0,1.0,1.0,1.0]\n",
       "}\n",
       "}],\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Dodge\"\n",
       "},\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[]\n",
       "},\n",
       "\"height\":250\n",
       "},{\n",
       "\"x\":0,\n",
       "\"width\":500,\n",
       "\"y\":250,\n",
       "\"feature_spec\":{\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"v\",\n",
       "\"fill\":\"@as_discrete@c\"\n",
       "},\n",
       "\"stat\":\"count\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":{\n",
       "\"name\":\"jitter\",\n",
       "\"width\":0.2\n",
       "},\n",
       "\"geom\":\"bar\",\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"fill\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"c\"\n",
       "}\n",
       "}]\n",
       "},\n",
       "\"data\":{\n",
       "\"v\":[4.0,3.0,1.0,2.0,0.0,4.0,2.0,0.0,3.0,1.0],\n",
       "\"..count..\":[14.0,10.0,6.0,12.0,6.0,18.0,9.0,6.0,8.0,11.0],\n",
       "\"@as_discrete@c\":[0.0,0.0,0.0,0.0,0.0,1.0,1.0,1.0,1.0,1.0]\n",
       "}\n",
       "}],\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Jitter\"\n",
       "},\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[]\n",
       "},\n",
       "\"height\":250\n",
       "},{\n",
       "\"x\":500,\n",
       "\"width\":500,\n",
       "\"y\":250,\n",
       "\"feature_spec\":{\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"v\",\n",
       "\"fill\":\"@as_discrete@c\"\n",
       "},\n",
       "\"stat\":\"count\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":\"stack\",\n",
       "\"geom\":\"bar\",\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"fill\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"c\"\n",
       "}\n",
       "}]\n",
       "},\n",
       "\"data\":{\n",
       "\"v\":[4.0,3.0,1.0,2.0,0.0,4.0,2.0,0.0,3.0,1.0],\n",
       "\"..count..\":[14.0,10.0,6.0,12.0,6.0,18.0,9.0,6.0,8.0,11.0],\n",
       "\"@as_discrete@c\":[0.0,0.0,0.0,0.0,0.0,1.0,1.0,1.0,1.0,1.0]\n",
       "}\n",
       "}],\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Stack\"\n",
       "},\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[]\n",
       "},\n",
       "\"height\":250\n",
       "},{\n",
       "\"x\":0,\n",
       "\"width\":500,\n",
       "\"y\":500,\n",
       "\"feature_spec\":{\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"v\",\n",
       "\"fill\":\"@as_discrete@c\"\n",
       "},\n",
       "\"stat\":\"count\",\n",
       "\"alpha\":0.5,\n",
       "\"position\":\"nudge\",\n",
       "\"geom\":\"bar\",\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"fill\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"c\"\n",
       "}\n",
       "}]\n",
       "},\n",
       "\"data\":{\n",
       "\"v\":[4.0,3.0,1.0,2.0,0.0,4.0,2.0,0.0,3.0,1.0],\n",
       "\"..count..\":[14.0,10.0,6.0,12.0,6.0,18.0,9.0,6.0,8.0,11.0],\n",
       "\"@as_discrete@c\":[0.0,0.0,0.0,0.0,0.0,1.0,1.0,1.0,1.0,1.0]\n",
       "}\n",
       "}],\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Nudge\"\n",
       "},\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[]\n",
       "},\n",
       "\"height\":250\n",
       "},{\n",
       "\"x\":500,\n",
       "\"width\":500,\n",
       "\"y\":500,\n",
       "\"feature_spec\":{\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "\"x\":\"v\",\n",
       "\"fill\":\"@as_discrete@c\"\n",
       "},\n",
       "\"stat\":\"count\",\n",
       "\"alpha\":0.8,\n",
       "\"position\":\"fill\",\n",
       "\"geom\":\"bar\",\n",
       "\"data_meta\":{\n",
       "\"mapping_annotations\":[{\n",
       "\"aes\":\"fill\",\n",
       "\"annotation\":\"as_discrete\",\n",
       "\"parameters\":{\n",
       "\"label\":\"c\"\n",
       "}\n",
       "}]\n",
       "},\n",
       "\"data\":{\n",
       "\"v\":[4.0,3.0,1.0,2.0,0.0,4.0,2.0,0.0,3.0,1.0],\n",
       "\"..count..\":[14.0,10.0,6.0,12.0,6.0,18.0,9.0,6.0,8.0,11.0],\n",
       "\"@as_discrete@c\":[0.0,0.0,0.0,0.0,0.0,1.0,1.0,1.0,1.0,1.0]\n",
       "}\n",
       "}],\n",
       "\"ggtitle\":{\n",
       "\"text\":\"Fill\"\n",
       "},\n",
       "\"mapping\":{\n",
       "},\n",
       "\"data\":{\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[]\n",
       "},\n",
       "\"height\":250\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"bnW1dg\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 5,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val p1 = ggplot(data) +\n",
    "    geomBar(alpha = 0.8, position = positionDodge(0.5)) { x = \"v\"; fill = asDiscrete(\"c\") }\n",
    "\n",
    "val p2 = ggplot(data) +\n",
    "    geomBar(alpha = 0.8, position = positionJitter(0.2) ) { x = \"v\"; fill = asDiscrete(\"c\") }\n",
    "\n",
    "val p3 = ggplot(data) +\n",
    "    geomBar(alpha = 0.8, position = positionStack() ) { x = \"v\"; fill = asDiscrete(\"c\") }\n",
    "\n",
    "val p4 = ggplot(data) +\n",
    "    geomBar(alpha = 0.5, position = positionNudge() ) { x = \"v\"; fill = asDiscrete(\"c\") }\n",
    "\n",
    "val p5 = ggplot(data) +\n",
    "    geomBar(alpha = 0.8, position = positionFill() ) { x = \"v\"; fill = asDiscrete(\"c\") }\n",
    "\n",
    "GGBunch()\n",
    "    .addPlot(p0 + ggtitle(\"Without Position\"), 0, 0, 500, 250)\n",
    "    .addPlot(p1 + ggtitle(\"Dodge\"), 500, 0, 500, 250)\n",
    "    .addPlot(p2 + ggtitle(\"Jitter\"), 0, 250, 500, 250)\n",
    "    .addPlot(p3 + ggtitle(\"Stack\"), 500, 250, 500, 250)\n",
    "    .addPlot(p4 + ggtitle(\"Nudge\"), 0, 500, 500, 250)\n",
    "    .addPlot(p5 + ggtitle(\"Fill\"), 500, 500, 500, 250)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "13e281b4-6699-4584-a873-8797a1c213ea",
   "metadata": {},
   "source": [
    "### Features"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "ad1df677-1ca5-4c9f-9583-2d65f61e5e9c",
   "metadata": {},
   "source": [
    "The entire plot can be provided with additional *features layers*.\n",
    "The features can be grouped in the following categories:;\n",
    "- **Scale**: enables choosing a [`scale`](https://lets-plot.org/kotlin/-lets--plot--kotlin/org.jetbrains.letsPlot.scale/index.html) for each mapped variable, depending on its attributes. With scales, we can tweak things like, the axis labels, legends keys, aesthetics (like the fill color) and so on.\n",
    "- **Coordinate System**: determine how x and y aesthetics combine, to position elements in the plot. (i.e. for overriding default axes ratio we can use  `coordFixed(ratio = 2)`).\n",
    "- **Legend**: we can customize the legend (i.e. the number of columns) by using the `guide` methods, or the `guide` argument inside a `scale` method. The location of the legend can be tweaked with [`theme`'s methods](https://lets-plot.org/kotlin/-lets--plot--kotlin/org.jetbrains.letsPlot.themes/theme/index.html).\n",
    "- **Sampling**: we can pick samples of the dataset (sampling is applied *after* `stat` transformations), and if the dataset exceeds a certain threshold, sampling is applied automatically (the `samplingNone` value disables any sampling for the given layer). See the [`sampling` documentation](https://lets-plot.org/kotlin/-lets--plot--kotlin/org.jetbrains.letsPlot.sampling/index.html) for more."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "ccaf38dc-1343-4207-95a4-06b36c9b1712",
   "metadata": {},
   "source": [
    "## Integration with Kotlin DataFrame"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "47d66021-d9ac-460c-a90a-f2c8510ee2a1",
   "metadata": {},
   "source": [
    "As you might have already seen, `DataFrame` objects has the `toMap()` method, making plotting a dataframe a trivial task.\n",
    "Let's see an example on how we can integrate all the libraries that we have seen all together for computing and showing the log difference of two variables."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "id": "1139a71c-57c4-4ac0-989f-2358712ce94f",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "   year quarter  realgdp realcons realinv realgovt realdpi   cpi    m1 tbilrate unemp     pop infl realint\n",
      " 0 1959       1 2710.349   1707.4 286.898  470.045  1886.9 28.98 139.7     2.82   5.8 177.146 0.00    0.00\n",
      " 1 1959       2 2778.801   1733.7 310.859  481.301  1919.7 29.15 141.7     3.08   5.1 177.830 2.34    0.74\n",
      "\n"
     ]
    }
   ],
   "source": [
    "val df = DataFrame.readCSV(\"../resources/example-datasets/datasets/macrodata.csv\")\n",
    "df.head(5)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 132,
   "id": "9acbb8e0-eda5-4f38-8457-07d4a656e138",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "application/kotlindataframe+json": "{\"nrow\":5,\"ncol\":4,\"columns\":[\"cpi\",\"m1\",\"tbilrate\",\"unemp\"],\"kotlin_dataframe\":[{\"cpi\":28.98,\"m1\":139.7,\"tbilrate\":2.82,\"unemp\":5.8},{\"cpi\":29.15,\"m1\":141.7,\"tbilrate\":3.08,\"unemp\":5.1},{\"cpi\":29.35,\"m1\":140.5,\"tbilrate\":3.82,\"unemp\":5.3},{\"cpi\":29.37,\"m1\":140.0,\"tbilrate\":4.33,\"unemp\":5.6},{\"cpi\":29.54,\"m1\":139.6,\"tbilrate\":3.5,\"unemp\":5.2}]}",
      "text/html": [
       "        <html>\n",
       "        <head>\n",
       "            <style type=\"text/css\">\n",
       "                :root {\n",
       "    --background: #fff;\n",
       "    --background-odd: #f5f5f5;\n",
       "    --background-hover: #d9edfd;\n",
       "    --header-text-color: #474747;\n",
       "    --text-color: #848484;\n",
       "    --text-color-dark: #000;\n",
       "    --text-color-medium: #737373;\n",
       "    --text-color-pale: #b3b3b3;\n",
       "    --inner-border-color: #aaa;\n",
       "    --bold-border-color: #000;\n",
       "    --link-color: #296eaa;\n",
       "    --link-color-pale: #296eaa;\n",
       "    --link-hover: #1a466c;\n",
       "}\n",
       "\n",
       ":root[theme=\"dark\"], :root [data-jp-theme-light=\"false\"], .dataframe_dark{\n",
       "    --background: #303030;\n",
       "    --background-odd: #3c3c3c;\n",
       "    --background-hover: #464646;\n",
       "    --header-text-color: #dddddd;\n",
       "    --text-color: #b3b3b3;\n",
       "    --text-color-dark: #dddddd;\n",
       "    --text-color-medium: #b2b2b2;\n",
       "    --text-color-pale: #737373;\n",
       "    --inner-border-color: #707070;\n",
       "    --bold-border-color: #777777;\n",
       "    --link-color: #008dc0;\n",
       "    --link-color-pale: #97e1fb;\n",
       "    --link-hover: #00688e;\n",
       "}\n",
       "\n",
       "p.dataframe_description {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe {\n",
       "    font-family: \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n",
       "    font-size: 12px;\n",
       "    background-color: var(--background);\n",
       "    color: var(--text-color-dark);\n",
       "    border: none;\n",
       "    border-collapse: collapse;\n",
       "}\n",
       "\n",
       "table.dataframe th, td {\n",
       "    padding: 6px;\n",
       "    border: 1px solid transparent;\n",
       "    text-align: left;\n",
       "}\n",
       "\n",
       "table.dataframe th {\n",
       "    background-color: var(--background);\n",
       "    color: var(--header-text-color);\n",
       "}\n",
       "\n",
       "table.dataframe td {\n",
       "    vertical-align: top;\n",
       "}\n",
       "\n",
       "table.dataframe th.bottomBorder {\n",
       "    border-bottom-color: var(--bold-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(odd) {\n",
       "    background: var(--background-odd);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:nth-child(even) {\n",
       "    background: var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe tbody > tr:hover {\n",
       "    background: var(--background-hover);\n",
       "}\n",
       "\n",
       "table.dataframe a {\n",
       "    cursor: pointer;\n",
       "    color: var(--link-color);\n",
       "    text-decoration: none;\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover > td a {\n",
       "    color: var(--link-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe a:hover {\n",
       "    color: var(--link-hover);\n",
       "    text-decoration: underline;\n",
       "}\n",
       "\n",
       "table.dataframe img {\n",
       "    max-width: fit-content;\n",
       "}\n",
       "\n",
       "table.dataframe th.complex {\n",
       "    background-color: var(--background);\n",
       "    border: 1px solid var(--background);\n",
       "}\n",
       "\n",
       "table.dataframe .leftBorder {\n",
       "    border-left-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightBorder {\n",
       "    border-right-color: var(--inner-border-color);\n",
       "}\n",
       "\n",
       "table.dataframe .rightAlign {\n",
       "    text-align: right;\n",
       "}\n",
       "\n",
       "table.dataframe .expanderSvg {\n",
       "    width: 8px;\n",
       "    height: 8px;\n",
       "    margin-right: 3px;\n",
       "}\n",
       "\n",
       "table.dataframe .expander {\n",
       "    display: flex;\n",
       "    align-items: center;\n",
       "}\n",
       "\n",
       "/* formatting */\n",
       "\n",
       "table.dataframe .null {\n",
       "    color: var(--text-color-pale);\n",
       "}\n",
       "\n",
       "table.dataframe .structural {\n",
       "    color: var(--text-color-medium);\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .dataFrameCaption {\n",
       "    font-weight: bold;\n",
       "}\n",
       "\n",
       "table.dataframe .numbers {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe td:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "table.dataframe tr:hover .formatted .structural, .null {\n",
       "    color: var(--text-color-dark);\n",
       "}\n",
       "\n",
       "\n",
       "\n",
       "\n",
       "            </style>\n",
       "        </head>\n",
       "        <body>\n",
       "            \n",
       "<table class=\"dataframe\" id=\"df_469762098\"></table>\n",
       "\n",
       "<p class=\"dataframe_description\">DataFrame: rowsCount = 5, columnsCount = 4</p>\n",
       "        </body>\n",
       "        <script>\n",
       "            \n",
       "/*<!--*/\n",
       "call_DataFrame(function() { DataFrame.addTable({ cols: [{ name: \"<span title=\\\"cpi: Double\\\">cpi</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">28.98</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">29.15</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">29.35</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">29.37</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">29.54</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"m1: Double\\\">m1</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">139.7</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">141.7</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">140.5</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">140.0</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">139.6</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"tbilrate: Double\\\">tbilrate</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">2.82</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3.08</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3.82</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">4.33</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">3.50</span></span>\"] }, \n",
       "{ name: \"<span title=\\\"unemp: Double\\\">unemp</span>\", children: [], rightAlign: true, values: [\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5.8</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5.1</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5.3</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5.6</span></span>\",\"<span class=\\\"formatted\\\" title=\\\"\\\"><span class=\\\"numbers\\\">5.2</span></span>\"] }, \n",
       "], id: 469762098, rootId: 469762098, totalRows: 5 } ) });\n",
       "/*-->*/\n",
       "\n",
       "call_DataFrame(function() { DataFrame.renderTable(469762098) });\n",
       "\n",
       "\n",
       "        </script>\n",
       "        </html>"
      ]
     },
     "execution_count": 132,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "val df1 =  df[\"cpi\", \"m1\", \"tbilrate\", \"unemp\"]\n",
    "df1.head(5)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "cc6c9a74-2749-4234-aae5-fb2c87521723",
   "metadata": {},
   "source": [
    "We select `m1` and `unemp` variables and make a scatter plot with a regression line (`geomSmooth()`)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 133,
   "id": "eb7c6b72-4879-4f6c-a6e5-6d190877ec25",
   "metadata": {
    "tags": []
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "   <div id=\"fM9Vnl\"></div>\n",
       "   <script type=\"text/javascript\" data-lets-plot-script=\"plot\">\n",
       "       (function() {\n",
       "           var plotSpec={\n",
       "\"mapping\":{\n",
       "\"x\":\"m1\",\n",
       "\"y\":\"unemp\"\n",
       "},\n",
       "\"data\":{\n",
       "\"m1\":[0.014214880433718768,-0.008504657922833836,-0.0035650661644970327,-0.002861232281031967,0.004288784272217683,0.004980444304145237,0.00141843995413371,0.007062176244286178,0.00561404983276681,0.008362418069654431,0.007604599385219402,0.0082304991365163,6.828269299106182E-4,0.0013642566918132815,0.010847563994951237,0.009396042281696104,0.010631329368727016,0.008555498056046495,0.0071825316941938055,0.0071313106110766356,0.012837146760680263,0.01519016549397545,0.00937799933318395,0.008057062488917133,0.0067671743945840745,0.01762427872957595,0.01850246754799123,0.01584075364562043,-0.008769421881512862,0.005270876038999006,0.00408044868116253,0.013291152029598408,0.022141125877213952,0.019461275871576866,0.014758398508584847,0.012402423737465362,0.020684906153512372,0.018205964496572413,0.023937990494443007,0.010015106244520844,0.004970189157874394,0.00593180187160236,0.01613332475109086,0.0024218951048631254,0.006269613013595077,0.023284492198116347,0.012138337644368669,0.02066663680855907,0.02202831261290772,0.010174827881726856,0.01268331019432356,0.023621454736111325,0.013490929741015734,0.02563182902628025,0.026184778995066438,0.004760024854354228,0.01881670570964289,0.005808341595746391,0.018363178583676643,0.012806201379276239,0.007828558155063448,0.011078399862160637,0.005858676589317824,0.008362164706159803,0.026792100839613475,0.005974363227930546,0.010456700368058236,0.02160948433285448,0.008447423099955387,0.016021704531265613,0.02064631751723489,0.024668878694807717,0.013203586975701675,0.019177822527337796,0.024214258120594856,0.016313575491524013,0.02240093668916643,0.016265160973862436,0.014890006805932998,0.02587537699789877,0.024692612590371255,0.009498752157908186,0.013044797554417897,-0.005197516898029164,0.02622932572433445,0.03736424674486827,0.005607719193576166,0.038397467648668915,-0.0011705491211309038,0.0035075448096772988,0.032835001164501776,0.009889943501839582,0.0020109491750499586,0.03616832583890783,0.026974131969867976,0.03297908106642833,0.02917289798038869,0.01834197762712453,0.01515907374611114,0.018678026252192836,0.010967671981375382,0.005163205274492988,0.0241676157754096,0.023772629172801985,0.032258079427555764,0.03124993195505077,0.02212911647625404,0.03105445996172307,0.04469591644324211,0.03604257695636992,0.04955051890125439,0.01858814797575903,-0.0012105724795361539,0.01760984673907373,0.0,0.015614041547803659,0.017167249616333535,0.0024285817522224917,0.0030592758085834504,-0.008307287853450696,-0.0017983306066788884,0.01125043827606298,0.011125272775880823,0.01348671790947531,0.004825846153379665,0.01190271123379194,0.008986095683927608,0.019157674032933336,0.02147087818088611,0.018971537667132665,0.036237469736949635,0.0360302159202206,0.020346795262269346,0.04128700266627661,0.026154278129256525,0.016554757283467225,0.034617217633372555,0.025940021008615588,0.016573488151866655,0.008360149013221907,0.008203921034787065,-3.477353768852609E-4,0.001129698143174096,-0.0018255318669968545,-0.0033991404149551485,-0.007096888769358323,-0.012208219565015277,0.0011564294310169032,-0.011085398696590865,-0.023926545073819305,-0.00424433189287754,-0.01650156308489592,0.002253522080443382,-6.567528499887842E-4,0.008318193670356244,0.0015810279973189623,-0.001022732644583968,0.010180559932117639,0.010806955621908365,0.003727785377942716,-0.002908299786896329,0.003271243262433998,0.017624770581649685,-0.007515468853497076,-0.00947446744391911,-0.003906077546667497,-9.105810135645598E-4,0.01554763308025553,0.02200035508816356,0.02281401804874772,0.021130235863513036,-0.004207343803201091,0.011402823308999999,0.003744543589016658,0.0187598063713299,0.017453578156528593,0.03115025350200007,0.007272196678341558,0.006760416006509118,0.0197110467739412,0.006286034318597089,0.015177044975452247,0.004106179695211765,-0.006460160479131005,0.006460160479131005,0.006127827753993564,0.004064456168704211,-7.243489916675117E-5,-0.008219124714178072,1.4606003093220465E-4,0.0030623428963032495,0.004431053630721493,-0.007055344391816654,0.006692881087257518,-0.0013059567988307208,0.004780193067016825,0.018115270019850804,0.04536145205942965,0.06675262072822008,0.010286273764871012,0.037461255617571965,0.01220150374101614],\n",
       "\"unemp\":[-0.1286173778220936,0.03846628082779602,0.05505977718302746,-0.07410797215372189,0.0,0.07410797215372189,0.11778303565638337,0.07637297878457416,0.028987536873252173,-0.028987536873252173,-0.09237332013101507,-0.10178269430994247,-0.01801850550267825,0.01801850550267825,-0.01801850550267825,0.05310982531394837,-0.01739174271186905,-0.035718082602079315,0.01801850550267825,-0.01801850550267825,-0.05608946665104364,-0.03922071315328135,0.0,-0.020202707317519275,-0.04167269640056803,-0.06595796779179741,-0.07061756721395351,-0.05001042057466143,-0.02597548640326064,0.0,-0.02666824708216109,0.02666824708216109,0.0,0.0,0.02597548640326064,-0.05264373348542173,-0.055569851154810834,0.0,-0.028987536873252395,0.0,0.0,0.057158413839948574,0.0,0.1541506798272585,0.13353139262452252,0.08004270767353638,0.109199291964992,0.017094433359300165,0.0,0.016807118316381153,0.0,-0.03390155167568132,-0.01739174271186905,-0.017699577099401065,-0.05505977718302746,-0.05826890812397578,-0.020202707317519275,-0.02061928720273576,0.0,0.0606246218164348,0.019418085857101586,0.07410797215372189,0.1643030512912762,0.21706450523782772,0.08191712246788674,-0.045985113241823417,-0.023810648693718406,-0.07503518594291414,-0.013072081567353067,0.013072081567353067,0.012903404835908017,-0.03922071315328157,-0.05480823649499489,-0.028573372444056,-0.04445176257083405,-0.04652001563489283,-0.04879016416943194,0.0,-0.016807118316381153,0.0,-0.03448617607116922,0.03448617607116922,0.0,0.06559728248581309,0.1473247147568586,0.05334598070529273,-0.039740328649513934,0.0,0.0,0.0,0.10265415406008316,0.07061756721395351,0.06595796779179741,0.05182506786458596,0.07770898432731599,-0.028437935320533292,-0.02927038230011325,-0.0718257345712554,-0.1006435257796876,-0.07320340402329473,-0.051959738930711374,-0.013423020332140378,-0.013605652055778794,0.0,0.0,-0.013793322132335861,-0.0281708769666964,0.0,0.0281708769666964,-0.0281708769666964,-0.028987536873252173,-0.029852963149681333,-0.04652001563489283,-0.04879016416943194,-0.016807118316381153,-0.03448617607116922,-0.035718082602079315,0.0,-0.03704127168034921,-0.019048194970694432,0.0,0.019048194970694432,0.01869213301215278,-0.01869213301215278,0.0,0.07275935428242852,0.06782259633876087,0.07878087785311427,0.029852963149681333,0.01459879942115272,0.028573372444056,0.04138521616285451,0.026668247082160867,0.0,-0.026668247082160867,-0.027398974188114655,-0.013986241974739855,-0.04317217186520872,-0.029852963149681333,0.0,-0.06252035698133374,-0.03278982282299103,-0.06899287148695143,-0.01801850550267825,0.035718082602079315,0.0,-0.017699577099401065,-0.01801850550267825,0.0,-0.03704127168034921,0.0,-0.019048194970694432,-0.03922071315328135,-0.020202707317519275,-0.04167269640056803,-0.021506205220963803,-0.04445176257083361,0.022472855852058604,-0.022472855852058604,-0.022989518224698857,0.0,-0.023530497410193973,-0.024097551579060683,-0.024692612590371477,-0.025317807984289953,0.025317807984289953,-0.025317807984289953,0.07410797215372211,0.04652001563489283,0.08701137698962969,0.13613217432458002,0.035718082602079315,0.01739174271186905,-0.01739174271186905,0.01739174271186905,0.017094433359300165,0.049596941139372186,-0.016260520871780537,-0.050430853626891814,-0.01739174271186905,-0.017699577099401065,-0.03636764417087468,0.0,-0.01869213301215278,-0.03846628082779602,-0.019802627296179764,-0.020202707317519275,-0.04167269640056803,0.0,0.0,-0.06595796779179741,0.022472855852058604,0.0,0.04348511193973881,0.021053409197832273,0.02061928720273576,0.09716374845364784,0.10536051565782611,0.13976194237515882,0.16034265007517945,0.12733942237660134,0.04255961441879608]\n",
       "},\n",
       "\"kind\":\"plot\",\n",
       "\"scales\":[],\n",
       "\"layers\":[{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"identity\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"point\",\n",
       "\"data\":{\n",
       "}\n",
       "},{\n",
       "\"mapping\":{\n",
       "},\n",
       "\"stat\":\"smooth\",\n",
       "\"position\":\"identity\",\n",
       "\"geom\":\"smooth\",\n",
       "\"data\":{\n",
       "\"m1\":[-0.023926545073819305,-0.02277870753202134,-0.021630869990223373,-0.020483032448425406,-0.01933519490662744,-0.018187357364829473,-0.017039519823031504,-0.015891682281233537,-0.01474384473943557,-0.013596007197637604,-0.012448169655839638,-0.01130033211404167,-0.010152494572243704,-0.009004657030445737,-0.007856819488647769,-0.006708981946849803,-0.005561144405051836,-0.00441330686325387,-0.0032654693214559036,-0.002117631779657937,-9.697942378599708E-4,1.7804330393799903E-4,0.0013258808457359654,0.0024737183875339318,0.003621555929331898,0.0047693934711298645,0.005917231012927831,0.007065068554725797,0.008212906096523767,0.009360743638321734,0.0105085811801197,0.011656418721917666,0.012804256263715633,0.013952093805513599,0.015099931347311565,0.016247768889109532,0.017395606430907498,0.018543443972705465,0.01969128151450343,0.020839119056301397,0.021986956598099364,0.023134794139897337,0.024282631681695303,0.02543046922349327,0.026578306765291236,0.027726144307089202,0.02887398184888717,0.030021819390685135,0.0311696569324831,0.03231749447428107,0.033465332016079034,0.034613169557877,0.03576100709967497,0.036908844641472933,0.0380566821832709,0.03920451972506887,0.04035235726686684,0.041500194808664806,0.04264803235046277,0.04379586989226074,0.044943707434058705,0.04609154497585667,0.04723938251765464,0.048387220059452604,0.04953505760125057,0.05068289514304854,0.0518307326848465,0.05297857022664447,0.054126407768442436,0.0552742453102404,0.05642208285203837,0.057569920393836335,0.0587177579356343,0.05986559547743227,0.061013433019230234,0.0621612705610282,0.06330910810282617,0.06445694564462413,0.0656047831864221,0.06675262072822007],\n",
       "\"..ymax..\":[0.0018327365862520033,0.0019333784728008153,0.002036427588375009,0.002142104336272342,0.0022506557439945507,0.0023623594078955173,0.002477528116338827,0.0025965152797166203,0.0027197213203950608,0.0028476012043628356,0.002980673329054665,0.0031195300179318528,0.0032648499103394898,0.0034174125715912274,0.003578115676918691,0.0037479951329382147,0.00392824847337714,0.00412026177262695,0.004325640115878495,0.00454624128099578,0.0047842116310857575,0.005042022167641128,0.005322501119611994,0.005628857243074057,0.005964685207616047,0.006333941379036244,0.006740875845695684,0.007189906306371199,0.007685423753975492,0.008231530979792113,0.008831733173012305,0.00948862161371647,0.010203608066748159,0.010976768474250151,0.011806834313161998,0.012691333818142827,0.01362684814926173,0.014609325097555331,0.0156343916657169,0.016697622231434305,0.017794740658165338,0.018921753629090585,0.020075024402970817,0.02125130116496666,0.022447714298510862,0.023661754594919565,0.024891241362551865,0.026134286545025448,0.02738925868573117,0.02865474893546644,0.029929540199017793,0.03121257982301838,0.032502955818658114,0.033799876391910566,0.03510265245094636,0.036410682727822205,0.03772344115851407,0.0390404661926207,0.04036135174001038,0.04168573949965986,0.043013312452349885,0.0443437893319997,0.04567691991958403,0.047012481028724254,0.048350273073432835,0.049690117126510364,0.051031852392181894,0.05237533402914115,0.05372043127063614,0.05506702579692371,0.05641501032263968,0.05776428736762682,0.05911476818474765,0.0604663718223552,0.06181902430255235,0.06317265789925462,0.06452721050248461,0.06588262505734799,0.06723884906783864,0.06859583415704953],\n",
       "\"..ymin..\":[-0.04217191282771056,-0.04083609428723614,-0.039502682975787115,-0.038171899296661226,-0.03684399027736021,-0.035519233514237955,-0.03419794179565804,-0.03288046853201261,-0.03156721414566783,-0.030258633602612377,-0.02895524530028098,-0.027657641562134946,-0.026366501027519362,-0.025082603261747875,-0.023806845940052113,-0.022540264969048415,-0.021284057882464118,-0.020039610754690705,-0.018808528670919027,-0.017592669409013086,-0.01639417933207984,-0.015215529441611985,-0.014059547966559626,-0.012929443662998466,-0.011828811200517233,-0.010761606944914208,-0.009732080984550424,-0.008744651018202716,-0.007803708038783781,-0.0069133548375771795,-0.006077096603774149,-0.005297524617455089,-0.004576050643463554,-0.0039127506239423245,-0.0033063560358309483,-0.0027543951137885556,-0.002253449017884235,-0.0017994655391546134,-0.0013880716802929585,-0.0010148418189871392,-6.754998186949499E-4,-3.66052362596965E-4,-8.286270945397425E-5,1.773209555734085E-4,4.1736824905242755E-4,6.397883796669494E-4,8.467620390578724E-4,0.001040177283607514,0.0012216655699250137,0.0013926357472129666,0.0015543049106848412,0.0017077257137074735,0.001853810145090968,0.001993349998861735,0.0021270343668491655,0.0022554645169965415,0.0023791665133278996,0.0024986019062444922,0.002614176785878032,0.0027262494532517903,0.00283513692758499,0.002941120474958401,0.00304445031439729,0.0031453496322802928,0.0032440180145949307,0.0033406343885406253,0.003435359549892318,0.0035283383399562843,0.00361970152548452,0.0037095674262201637,0.0037980433275274263,0.0038852267095635037,0.003971206319465896,0.004056063108881569,0.004139871055707643,0.004222697886028599,0.004304605709821833,0.004385651581981682,0.004465887998514238,0.004545363336326581],\n",
       "\"unemp\":[-0.020169588120729276,-0.019451357907217665,-0.018733127693706053,-0.01801489748019444,-0.01729666726668283,-0.01657843705317122,-0.015860206839659607,-0.015141976626147994,-0.014423746412636383,-0.013705516199124771,-0.012987285985613158,-0.012269055772101547,-0.011550825558589935,-0.010832595345078324,-0.01011436513156671,-0.0093961349180551,-0.008677904704543488,-0.007959674491031877,-0.007241444277520265,-0.006523214064008654,-0.005804983850497041,-0.005086753636985428,-0.004368523423473816,-0.0036502932099622045,-0.002932062996450593,-0.0022138327829389817,-0.0014956025694273702,-7.773723559157588E-4,-5.9142142404144775E-5,6.590880711074667E-4,0.001377318284619078,0.0020955484981306895,0.002813778711642302,0.0035320089251539132,0.004250239138665525,0.004968469352177136,0.0056866995656887475,0.006404929779200359,0.00712315999271197,0.007841390206223582,0.008559620419735193,0.00927785063324681,0.009996080846758421,0.010714311060270034,0.011432541273781646,0.012150771487293257,0.012869001700804869,0.01358723191431648,0.014305462127828092,0.015023692341339703,0.015741922554851316,0.016460152768362928,0.01717838298187454,0.01789661319538615,0.018614843408897762,0.019333073622409373,0.020051303835920985,0.020769534049432596,0.021487764262944208,0.022205994476455826,0.022924224689967437,0.02364245490347905,0.02436068511699066,0.02507891533050227,0.025797145544013883,0.026515375757525494,0.027233605971037106,0.027951836184548717,0.02867006639806033,0.02938829661157194,0.03010652682508355,0.030824757038595163,0.031542987252106774,0.032261217465618386,0.03297944767913,0.03369767789264161,0.03441590810615322,0.03513413831966483,0.03585236853317644,0.036570598746688054]\n",
       "}\n",
       "}]\n",
       "};\n",
       "           var plotContainer = document.getElementById(\"fM9Vnl\");\n",
       "           window.letsPlotCall(function() {{\n",
       "               LetsPlot.buildPlotFromProcessedSpecs(plotSpec, -1, -1, plotContainer);\n",
       "           }});\n",
       "       })();    \n",
       "   </script>"
      ]
     },
     "execution_count": 133,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "// python equivalent: `np.log(df1).diff().dropna()`\n",
    "val trans_data =  df1.columns()\n",
    "    .map {\n",
    "        val data = it.toList()\n",
    "        mk.dnarray<Double, D1>(intArrayOf(data.size)) { data[it] as Double }\n",
    "    }.map { mk.math.log(it).toList() }\n",
    "    .mapIndexed { idx, x -> x.zipWithNext { a, b -> b - a }.toColumn(df1.columnNames()[idx]) }\n",
    "    .toDataFrame().dropNA()\n",
    "\n",
    "ggplot(trans_data[\"m1\", \"unemp\"].toMap()) { x=\"m1\"; y=\"unemp\" } +\n",
    "    geomPoint() + geomSmooth()\n"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "a5fc4e54-c2ad-48cb-903d-8523066b4520",
   "metadata": {},
   "source": [
    "The same result with Matplotlib would not be as easy as in Kotlin, unless [*Seaborn*](https://seaborn.pydata.org) would be used."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "281c836d-c52f-441c-a569-5a8beefdea05",
   "metadata": {},
   "source": [
    "## Conclusions"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "b2749092-fedb-4e5a-8369-ea6283edac10",
   "metadata": {},
   "source": [
    "In this chapter we have explored Lets-Plot library, a very powerful tool for visualizing data. This library and ggplot's APIs are used in a lot of different programming languages, so a solid knowledge of this library can be portable on other platforms.\n",
    "\n",
    "Its behavior is quite different from Python's Matplotlib, but if you know what you can get with Matplotlib, you can easily find a solution using Lets-Plot!\n",
    "\n",
    "This chapter wasn't intended to cover all capabilities of this library, but a basic understanding on how to build plots stacking together a series of layers, the ability to customize every aspect of it, and how easy it is to plot data from a `DataFrame`. The documentation provided from the Lets-Plot team is very good, with plenty of examples for every geometric objects, kind of plots, scales and much more."
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Kotlin",
   "language": "kotlin",
   "name": "kotlin"
  },
  "language_info": {
   "codemirror_mode": "text/x-kotlin",
   "file_extension": ".kt",
   "mimetype": "text/x-kotlin",
   "name": "kotlin",
   "nbconvert_exporter": "",
   "pygments_lexer": "kotlin",
   "version": "1.8.20"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
